/*
Ce mini Baromètre sur une base Arduino Nano avec un écran oled 0.96 ou 1.3 est largement inspiré du modèle de https://github.com/ingmar/nanobaro 
traduction et rajout de l'écran oled  et un peu de ménage dans la trame.


Et quelques demandes des copains d'Hisse et oh " https://www.hisse-et-oh.com/ " .
La demande :"faire un petit baromètre qui affiche une courbe et alarme quant une dépression se pointe
et compatible Nmea 0183 avec OpenCPN  " https://opencpn.org/ "  et qtVlm https://www.meltemus.com/index.php/fr/ autant sous Windows que sous Linux!

Rajout d'une tempo sur le temps entre deux trames envoyé à opencpn ou qtvlm pour limiter l'historique visible mit ici par defaut a 1 minute ligne 272


l'alarme se déclenche quant la différence entre l'ancienne mesure (régler ici tous les 15 minutes mais modifiable facilement) et la nouvelle mesure
est plus grande que 5 Hpa pour être exact la bonne valeur devrait être 15 Hpa sur 1 heures soit 22 pixels.

mais je préféré l'avoir sur 15 minutes donc valeur a peut prés 7 pixels à vous de voir !

le matos 1 arduino Nano, 1 capteur de pression type BME 280 en I2c ou 1 BMP 180 en I2C , 1 écran oled 128 X 64  en I2C aussi câblage standard plein d'exemple sur le net !

Je préfère le montage en I2C :

VIN   5V ou 3.3v suivant votre matos
GND   GND
SCL   pin A5
SDA   pin A4

par exemple :
http://arduino-er.blogspot.com/2015/04/walking-bitmap-on-096-inch-128x64-i2c.html

  

C'est ma seconde prise en main d’un Arduino (soyez indulgent !)'' .
Mais venez apporter vos corrections ou améliorations sur ce site ! Il y a quelques bricoleurs très sympas et beaucoup de compétences !
//Le croquis utilise 23666 octets (77%) de l'espace de stockage de programmes !!!


 Bonne nav a tous
A.guy

 
*/



#include <Wire.h>
#include "SparkFunBME280.h"
#include "U8glib.h"
#include <math.h>



//U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NO_ACK);  // Affichage qui n'envoie pas de courant alternatif
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NO_ACK);  // Si le premier fait une barre sur le coté essayez celui là ! j'utilise c'est deux types d'ecran ;=)

BME280 mySensor;

long temps;
long tempstrame;
int pmax =1020;
int pmin =980;

#define NMEA_TALKER_ID "WI" // Instruments météorologiques
#define NMEA_DELAY 10 // Envoyer des données toutes les 10 secondes
#define PRESS_OVERSAMPLING 2
String s;

float temp, pre,humidi;


int TA =0;
int Hpixel=0;
int hpixel[128];
char* tabprev[] = {"Tempete", "Pluie/Vent", "Variable","Beau Temps","Tres Sec"};
int inprev ;

const byte buff_len = 70;
char CRCbuffer[buff_len];
char prevtxt;
byte nmea_crc(String msg) {
  // NMEA CRC: XOR chaque octet avec le précédent pour tous les caractères entre '$' et '*'

  int i;
  byte crc = 0;
  for (i = 0; i < buff_len; i++) {
    crc ^= msg.charAt(i); // XOR
  }
  return crc;
}


void nmea_send(String sentence, String params) {
  String msg = String(NMEA_TALKER_ID) + sentence + params;

  msg.toCharArray(CRCbuffer, sizeof(CRCbuffer)); // mettre la chaîne complète dans CRCbuffer
  int crc = nmea_crc(CRCbuffer);

  if (crc < 16) msg += "0"; // pad with leading 0
  String hexcrc = String(crc, HEX);
  hexcrc.toUpperCase();
  Serial.println("$" + msg + "*" + hexcrc);


  
}

void nmea_txt(String text) {
  nmea_send("TXT", ",01,01,01," + text);
  
}




void tablimite() {

int labelmax[] = {980,1020,1060,1080};
int labelmin[] = {940,980,1020,1060};


int inlimit = map((pre)/100 ,940,1080,0,3);

inprev = map((pre)/100 ,940,1080,0,4);



pmax= labelmax[inlimit];
pmin= labelmin[inlimit];


}
////////////////////////////////////////////////////////////////////////////////////////////////
void draw_page_24H(void) {
  
   
u8g.setFont(u8g_font_5x7);
u8g.drawStr( 23, 6, "HPa");
u8g.drawLine(48, 8, 48, 64);
u8g.drawStr( 42, 6, "24 H");  
u8g.drawLine(96, 8, 96, 64);
u8g.drawStr( 90, 6, "48 H");


u8g.setPrintPos(0, 6);
u8g.print(pmax);

u8g.setPrintPos(0, 64);
u8g.print(pmin);
 u8g.drawStr( 23, 64, "HPa");

//if((millis() - temps) > 1000)// chaque 1 seconds pour test
//if((millis() - temps) > 10000)// chaque 10 seconds pour test
//if((millis() - temps) > 900000)//chaque 15 minutes pour mieux voir en details
if((millis() - temps) > 1800000)//chaque 30 minutes pensez a changer le 12 H en 24 H et le 24 H en 48 H sur les lignes 133 et 135



{
 temps = millis();


TA++ ;

if (TA ==128) {
TA = 0 ;}



Hpixel = map((pre)/100,pmin,pmax,60,0);

hpixel[TA]= (Hpixel);

  
}


u8g.setPrintPos((TA+5),(Hpixel));
u8g.print ((pre)/100,0);
 u8g.drawStr((TA+25),(Hpixel),"HPa");

for (int TA=0;TA<128;TA=TA+1) 

u8g.drawPixel (TA,hpixel[TA]); 

}

void draw_page_alarm(void) {
  // graphic commands to redraw the complete screen should be placed here  
  u8g.setFont(u8g_font_5x7);

if ( ((Hpixel)- hpixel[TA-1]  > 7)  & (hpixel[TA-1]>0) ) /// pour avoir 15 Hpa metre 22  à la place de 7

 { u8g.drawStr( 2, 6, "Alarme chute de pression");
 u8g.drawStr( 2, 16, "> 15 dPA");

 u8g.drawStr( 2, 36, "Risque de :");
 u8g.drawStr( 2, 46, "Enbata,Galerno,Gwalarn....");// dans ma zone de navigation c'est plutot l'Enbata a vous de mettre le nom de vos coups de vents locaux !!!  ;=)
 }

else
{ u8g.drawStr( 22, 6, " Pas d'Alarme"); 

u8g.setPrintPos(10, 36);

u8g.print(tabprev[inprev]);
}

}



void draw_tabgene (){


 temp = mySensor.readTempC();
 pre = mySensor.readFloatPressure();
 humidi =mySensor.readFloatHumidity();


   u8g.setFont(u8g_font_6x13);
    u8g.setFontRefHeightExtendedText();
    u8g.setDefaultForegroundColor();
    u8g.setFontPosTop();
    
    u8g.drawStr(2, 1, "Press :");
    u8g.setPrintPos(45, 1);
    u8g.print round(pre /100 );
    u8g.drawStr(76, 1, "hPa");
    
    
    u8g.drawStr(2, 15, "Temp :");
    u8g.setPrintPos(45, 15);
    u8g.print round(temp);
    u8g.drawStr(66, 15, "\xb0 C");
    

u8g.drawStr(2, 30, "Hum :");/// si vous n'utilisez pas de capteur BME 280 vous pouvez virer ces lignes ! sinon l'humidité affichera 0 %
    u8g.setPrintPos(45, 30);
    u8g.print round(humidi);
    u8g.drawStr(66, 30, "%");

 
}





void setup()
{
  Serial.begin(4800);
 // Serial.println("Example showing alternate I2C addresses");


mySensor.setI2CAddress(0x76);

  Wire.begin();
  Wire.setClock(400000); //Increase to fast I2C speed!

  mySensor.beginI2C();


//u8g.setRot180(); /// rotation ecran si besoin 
u8g.setContrast(3); /// reglage du contraste 


  
}

void updatenmea()
 {

  if((millis() - tempstrame) > 60000)// chaque 60 seconds envoie de la trame
  {
    tempstrame = millis();
      s = "";
      s = ",C," + String (round(temp)) + ",C,TempAir";
      s += ",P," + String(round(pre) / 100000.0, 5) + ",B,Barometer"; // OpenCPN ne semble pas vouloir Pascal (unité "P"), seulement Bar ("B")
      nmea_send("XDR", s);
    
     nmea_send("XDR,C", "," + String (round(temp)) + ",C,TempAir");
     nmea_send("XDR,P", "," + String (round(pre) / 100000.0, 5) + ",B,Barometer");
 }
     // delay(60000);
 
     
 }


void loop()
{


 
  u8g.firstPage();  
  do {

    tablimite();
    draw_page_24H();
  } while( u8g.nextPage() );

while( u8g.nextPage() );//end of picture loop

  delay(2500);
  
  u8g.firstPage();   
  do {
   draw_page_alarm();
   updatenmea(); //trame nmea 
  }
  while( u8g.nextPage() );//end of picture loop 


delay(2000);
  
  u8g.firstPage();   
  do {
   draw_tabgene();
  }
  while( u8g.nextPage() );//end of picture loop 


  
  // rebuild the picture after some delay
  delay(2500);
}
